#[doc = "Register `MC0` reader"]
pub struct R(crate::R<MC0_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<MC0_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<MC0_SPEC>> for R {
    fn from(reader: crate::R<MC0_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `MC0` writer"]
pub struct W(crate::W<MC0_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<MC0_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<MC0_SPEC>> for W {
    fn from(writer: crate::W<MC0_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `PLD0_MC_0` reader - Read Macrocell 0 for UDB\\[n\\]"]
pub struct PLD0_MC_0_R(crate::FieldReader<u8, u8>);
impl PLD0_MC_0_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD0_MC_0_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PLD0_MC_0_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC_0` reader - Read Macrocell 1 for UDB\\[n\\]"]
pub struct PLD1_MC_0_R(crate::FieldReader<u8, u8>);
impl PLD1_MC_0_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD1_MC_0_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PLD1_MC_0_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC_1` reader - Read Macrocell 0 for UDB\\[n+1\\]"]
pub struct PLD0_MC_1_R(crate::FieldReader<u8, u8>);
impl PLD0_MC_1_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD0_MC_1_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PLD0_MC_1_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC_1` reader - Read Macrocell 1 for UDB\\[n+1\\]"]
pub struct PLD1_MC_1_R(crate::FieldReader<u8, u8>);
impl PLD1_MC_1_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD1_MC_1_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PLD1_MC_1_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC_2` reader - Read Macrocell 0 for UDB\\[n+2\\]"]
pub struct PLD0_MC_2_R(crate::FieldReader<u8, u8>);
impl PLD0_MC_2_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD0_MC_2_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PLD0_MC_2_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC_2` reader - Read Macrocell 1 for UDB\\[n+2\\]"]
pub struct PLD1_MC_2_R(crate::FieldReader<u8, u8>);
impl PLD1_MC_2_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD1_MC_2_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PLD1_MC_2_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC_3` reader - Read Macrocell 0 for UDB\\[n+3\\]"]
pub struct PLD0_MC_3_R(crate::FieldReader<u8, u8>);
impl PLD0_MC_3_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD0_MC_3_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PLD0_MC_3_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC_3` reader - Read Macrocell 1 for UDB\\[n+3\\]"]
pub struct PLD1_MC_3_R(crate::FieldReader<u8, u8>);
impl PLD1_MC_3_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD1_MC_3_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PLD1_MC_3_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:3 - Read Macrocell 0 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn pld0_mc_0(&self) -> PLD0_MC_0_R {
        PLD0_MC_0_R::new((self.bits & 0x0f) as u8)
    }
    #[doc = "Bits 4:7 - Read Macrocell 1 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn pld1_mc_0(&self) -> PLD1_MC_0_R {
        PLD1_MC_0_R::new(((self.bits >> 4) & 0x0f) as u8)
    }
    #[doc = "Bits 8:11 - Read Macrocell 0 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn pld0_mc_1(&self) -> PLD0_MC_1_R {
        PLD0_MC_1_R::new(((self.bits >> 8) & 0x0f) as u8)
    }
    #[doc = "Bits 12:15 - Read Macrocell 1 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn pld1_mc_1(&self) -> PLD1_MC_1_R {
        PLD1_MC_1_R::new(((self.bits >> 12) & 0x0f) as u8)
    }
    #[doc = "Bits 16:19 - Read Macrocell 0 for UDB\\[n+2\\]"]
    #[inline(always)]
    pub fn pld0_mc_2(&self) -> PLD0_MC_2_R {
        PLD0_MC_2_R::new(((self.bits >> 16) & 0x0f) as u8)
    }
    #[doc = "Bits 20:23 - Read Macrocell 1 for UDB\\[n+2\\]"]
    #[inline(always)]
    pub fn pld1_mc_2(&self) -> PLD1_MC_2_R {
        PLD1_MC_2_R::new(((self.bits >> 20) & 0x0f) as u8)
    }
    #[doc = "Bits 24:27 - Read Macrocell 0 for UDB\\[n+3\\]"]
    #[inline(always)]
    pub fn pld0_mc_3(&self) -> PLD0_MC_3_R {
        PLD0_MC_3_R::new(((self.bits >> 24) & 0x0f) as u8)
    }
    #[doc = "Bits 28:31 - Read Macrocell 1 for UDB\\[n+3\\]"]
    #[inline(always)]
    pub fn pld1_mc_3(&self) -> PLD1_MC_3_R {
        PLD1_MC_3_R::new(((self.bits >> 28) & 0x0f) as u8)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "PLD Macrocell reading\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [mc0](index.html) module"]
pub struct MC0_SPEC;
impl crate::RegisterSpec for MC0_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [mc0::R](R) reader structure"]
impl crate::Readable for MC0_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [mc0::W](W) writer structure"]
impl crate::Writable for MC0_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets MC0 to value 0"]
impl crate::Resettable for MC0_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
